
show_title:
mov dx,offset prog_title
mov ah,9
int 21h


; examine length of parameters

mov al,[080]
cmp al,00
mov dx,offset no_param
jz error
dec al
mov di,offset file_name
mov si,081
mov bl,al
mov bh,00
mov [bx+di],bh
l1:
mov al,[bx+si]
mov [bx+di-1],al
cmp bx,0000
jz start
dec bx
jmp l1




; open sound file ...

start:

mov al,0
mov ah,3dh
mov dx,offset file_name
int 21h
mov dx,offset error1
jc error    ; if there was an error, cf is set.

mov file_handle,ax

;now move back to start of file...

mov al,00
mov bx,file_handle
mov cx,0000
mov dx,0000
mov ah,42h
int 21h

; now read the file into the buffer...

mov bx,file_handle
mov dx,offset file_buffer
mov cx,60000
mov ah,3fh
int 21h
mov dx,offset error2
jnc noerror

error:

mov ah,9
int 21h
jmp the_end

noerror:
mov cx,ax

mov bx,offset file_buffer
mov si,0000

; now to play the sample...

loopy:
cmp si,cx
jz the_end
mov al,[bx+si]
mov dx,768
out dx,al
call small_pause
inc si
jmp loopy

the_end:
mov bx,file_handle
mov ah,03e
int 21h
mov ah,4ch
int 21h

small_pause:
mov dx,028
l1:
dec dx
jnz l1
ret

; -----------------------------

prog_title: db 'Samplay - (c) 1992 Neil Johnson.',13,10,10,' -- Sample Player for DAC Board --',13,10,10,'$'
error1: db 'Error : could not open sound file.$'
error2: db 'Error : could not read file.$'
no_param: db 'Usage : samplay <file>',13,10,10,' where <file> is the sound file.$'
file_name: db 127 dup (?)
file_handle dw ?
file_length dw ?
file_buffer: db ?